/*
 * This file generated automatically from xparsec.xml by c_client.py.
 * Edit at your peril.
 */

/**
 * @defgroup XCB_XPARSEC_API XCB XPARSEC API
 * @brief XPARSEC XCB Protocol Implementation.
 * @{
 **/

#ifndef __XPARSEC_H
#define __XPARSEC_H

#include "xcb.h"
#include "xproto.h"

#ifdef __cplusplus
extern "C" {
#endif

#define XCB_XPARSEC_MAJOR_VERSION 1
#define XCB_XPARSEC_MINOR_VERSION 0

extern xcb_extension_t xcb_xparsec_id;

/**
 * @brief xcb_xparsec_query_version_cookie_t
 **/
typedef struct xcb_xparsec_query_version_cookie_t {
    unsigned int sequence;
} xcb_xparsec_query_version_cookie_t;

/** Opcode for xcb_xparsec_query_version. */
#define XCB_XPARSEC_QUERY_VERSION 0

/**
 * @brief xcb_xparsec_query_version_request_t
 **/
typedef struct xcb_xparsec_query_version_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    uint8_t  client_major;
    uint8_t  client_minor;
} xcb_xparsec_query_version_request_t;

/**
 * @brief xcb_xparsec_query_version_reply_t
 **/
typedef struct xcb_xparsec_query_version_reply_t {
    uint8_t  response_type;
    uint8_t  pad0;
    uint16_t sequence;
    uint32_t length;
    uint16_t server_major;
    uint16_t server_minor;
} xcb_xparsec_query_version_reply_t;

/**
 * @brief xcb_xparsec_get_drawable_context_cookie_t
 **/
typedef struct xcb_xparsec_get_drawable_context_cookie_t {
    unsigned int sequence;
} xcb_xparsec_get_drawable_context_cookie_t;

/** Opcode for xcb_xparsec_get_drawable_context. */
#define XCB_XPARSEC_GET_DRAWABLE_CONTEXT 7

/**
 * @brief xcb_xparsec_get_drawable_context_request_t
 **/
typedef struct xcb_xparsec_get_drawable_context_request_t {
    uint8_t        major_opcode;
    uint8_t        minor_opcode;
    uint16_t       length;
    xcb_drawable_t drawable;
} xcb_xparsec_get_drawable_context_request_t;

/**
 * @brief xcb_xparsec_get_drawable_context_reply_t
 **/
typedef struct xcb_xparsec_get_drawable_context_reply_t {
    uint8_t  response_type;
    uint8_t  pad0;
    uint16_t sequence;
    uint32_t length;
    uint32_t context_len;
    uint8_t  pad1[20];
} xcb_xparsec_get_drawable_context_reply_t;

/**
 * @brief xcb_xparsec_get_property_context_cookie_t
 **/
typedef struct xcb_xparsec_get_property_context_cookie_t {
    unsigned int sequence;
} xcb_xparsec_get_property_context_cookie_t;

/** Opcode for xcb_xparsec_get_property_context. */
#define XCB_XPARSEC_GET_PROPERTY_CONTEXT 12

/**
 * @brief xcb_xparsec_get_property_context_request_t
 **/
typedef struct xcb_xparsec_get_property_context_request_t {
    uint8_t      major_opcode;
    uint8_t      minor_opcode;
    uint16_t     length;
    xcb_window_t window;
    xcb_atom_t   property;
} xcb_xparsec_get_property_context_request_t;

/**
 * @brief xcb_xparsec_get_property_context_reply_t
 **/
typedef struct xcb_xparsec_get_property_context_reply_t {
    uint8_t  response_type;
    uint8_t  pad0;
    uint16_t sequence;
    uint32_t length;
    uint32_t context_len;
    uint8_t  pad1[20];
} xcb_xparsec_get_property_context_reply_t;

/**
 * @brief xcb_xparsec_get_selection_context_cookie_t
 **/
typedef struct xcb_xparsec_get_selection_context_cookie_t {
    unsigned int sequence;
} xcb_xparsec_get_selection_context_cookie_t;

/** Opcode for xcb_xparsec_get_selection_context. */
#define XCB_XPARSEC_GET_SELECTION_CONTEXT 19

/**
 * @brief xcb_xparsec_get_selection_context_request_t
 **/
typedef struct xcb_xparsec_get_selection_context_request_t {
    uint8_t    major_opcode;
    uint8_t    minor_opcode;
    uint16_t   length;
    xcb_atom_t selection;
} xcb_xparsec_get_selection_context_request_t;

/**
 * @brief xcb_xparsec_get_selection_context_reply_t
 **/
typedef struct xcb_xparsec_get_selection_context_reply_t {
    uint8_t  response_type;
    uint8_t  pad0;
    uint16_t sequence;
    uint32_t length;
    uint32_t context_len;
    uint8_t  pad1[20];
} xcb_xparsec_get_selection_context_reply_t;

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_xparsec_query_version_cookie_t
xcb_xparsec_query_version (xcb_connection_t *c,
                           uint8_t           client_major,
                           uint8_t           client_minor);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will cause
 * a reply to be generated. Any returned error will be
 * placed in the event queue.
 */
xcb_xparsec_query_version_cookie_t
xcb_xparsec_query_version_unchecked (xcb_connection_t *c,
                                     uint8_t           client_major,
                                     uint8_t           client_minor);

/**
 * Return the reply
 * @param c      The connection
 * @param cookie The cookie
 * @param e      The xcb_generic_error_t supplied
 *
 * Returns the reply of the request asked by
 *
 * The parameter @p e supplied to this function must be NULL if
 * xcb_xparsec_query_version_unchecked(). is used.
 * Otherwise, it stores the error if any.
 *
 * The returned value must be freed by the caller using free().
 */
xcb_xparsec_query_version_reply_t *
xcb_xparsec_query_version_reply (xcb_connection_t                    *c,
                                 xcb_xparsec_query_version_cookie_t   cookie  /**< */,
                                 xcb_generic_error_t                **e);

int
xcb_xparsec_get_drawable_context_sizeof (const void  *_buffer);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_xparsec_get_drawable_context_cookie_t
xcb_xparsec_get_drawable_context (xcb_connection_t *c,
                                  xcb_drawable_t    drawable);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will cause
 * a reply to be generated. Any returned error will be
 * placed in the event queue.
 */
xcb_xparsec_get_drawable_context_cookie_t
xcb_xparsec_get_drawable_context_unchecked (xcb_connection_t *c,
                                            xcb_drawable_t    drawable);

char *
xcb_xparsec_get_drawable_context_context (const xcb_xparsec_get_drawable_context_reply_t *R);

int
xcb_xparsec_get_drawable_context_context_length (const xcb_xparsec_get_drawable_context_reply_t *R);

xcb_generic_iterator_t
xcb_xparsec_get_drawable_context_context_end (const xcb_xparsec_get_drawable_context_reply_t *R);

/**
 * Return the reply
 * @param c      The connection
 * @param cookie The cookie
 * @param e      The xcb_generic_error_t supplied
 *
 * Returns the reply of the request asked by
 *
 * The parameter @p e supplied to this function must be NULL if
 * xcb_xparsec_get_drawable_context_unchecked(). is used.
 * Otherwise, it stores the error if any.
 *
 * The returned value must be freed by the caller using free().
 */
xcb_xparsec_get_drawable_context_reply_t *
xcb_xparsec_get_drawable_context_reply (xcb_connection_t                           *c,
                                        xcb_xparsec_get_drawable_context_cookie_t   cookie  /**< */,
                                        xcb_generic_error_t                       **e);

int
xcb_xparsec_get_property_context_sizeof (const void  *_buffer);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_xparsec_get_property_context_cookie_t
xcb_xparsec_get_property_context (xcb_connection_t *c,
                                  xcb_window_t      window,
                                  xcb_atom_t        property);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will cause
 * a reply to be generated. Any returned error will be
 * placed in the event queue.
 */
xcb_xparsec_get_property_context_cookie_t
xcb_xparsec_get_property_context_unchecked (xcb_connection_t *c,
                                            xcb_window_t      window,
                                            xcb_atom_t        property);

char *
xcb_xparsec_get_property_context_context (const xcb_xparsec_get_property_context_reply_t *R);

int
xcb_xparsec_get_property_context_context_length (const xcb_xparsec_get_property_context_reply_t *R);

xcb_generic_iterator_t
xcb_xparsec_get_property_context_context_end (const xcb_xparsec_get_property_context_reply_t *R);

/**
 * Return the reply
 * @param c      The connection
 * @param cookie The cookie
 * @param e      The xcb_generic_error_t supplied
 *
 * Returns the reply of the request asked by
 *
 * The parameter @p e supplied to this function must be NULL if
 * xcb_xparsec_get_property_context_unchecked(). is used.
 * Otherwise, it stores the error if any.
 *
 * The returned value must be freed by the caller using free().
 */
xcb_xparsec_get_property_context_reply_t *
xcb_xparsec_get_property_context_reply (xcb_connection_t                           *c,
                                        xcb_xparsec_get_property_context_cookie_t   cookie  /**< */,
                                        xcb_generic_error_t                       **e);

int
xcb_xparsec_get_selection_context_sizeof (const void  *_buffer);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_xparsec_get_selection_context_cookie_t
xcb_xparsec_get_selection_context (xcb_connection_t *c,
                                   xcb_atom_t        selection);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will cause
 * a reply to be generated. Any returned error will be
 * placed in the event queue.
 */
xcb_xparsec_get_selection_context_cookie_t
xcb_xparsec_get_selection_context_unchecked (xcb_connection_t *c,
                                             xcb_atom_t        selection);

char *
xcb_xparsec_get_selection_context_context (const xcb_xparsec_get_selection_context_reply_t *R);

int
xcb_xparsec_get_selection_context_context_length (const xcb_xparsec_get_selection_context_reply_t *R);

xcb_generic_iterator_t
xcb_xparsec_get_selection_context_context_end (const xcb_xparsec_get_selection_context_reply_t *R);

/**
 * Return the reply
 * @param c      The connection
 * @param cookie The cookie
 * @param e      The xcb_generic_error_t supplied
 *
 * Returns the reply of the request asked by
 *
 * The parameter @p e supplied to this function must be NULL if
 * xcb_xparsec_get_selection_context_unchecked(). is used.
 * Otherwise, it stores the error if any.
 *
 * The returned value must be freed by the caller using free().
 */
xcb_xparsec_get_selection_context_reply_t *
xcb_xparsec_get_selection_context_reply (xcb_connection_t                            *c,
                                         xcb_xparsec_get_selection_context_cookie_t   cookie  /**< */,
                                         xcb_generic_error_t                        **e);


#ifdef __cplusplus
}
#endif

#endif

/**
 * @}
 */
